#!/usr/bin/python3

import json
import os
import psycopg2
import sys
from psycopg2.extras import RealDictCursor
from importlib.machinery import SourceFileLoader

def deleteFeatureclasses(featureclassDeletes):
    success = True
    messages = []
    file = open("../.credentials/.postgresadmin")
    connection_string = file.readline()
    pg = psycopg2.connect(connection_string)
    query = pg.cursor(cursor_factory=RealDictCursor)
    try:
        sql = "BEGIN;"
        query.execute(sql)
        featureclasskeys = ""
        for featureclasskey in featureclassDeletes:
            if featureclasskeys != '':
                featureclasskeys += ","
            featureclasskeys += str(featureclasskey)
        sql = "DELETE FROM fews.featureclass WHERE featureclasskey IN (" + featureclasskeys + ");"
        query.execute(sql)
        sql = "COMMIT;"
        query.execute(sql)
        messages = ["Successfully deleted " + str(len(featureclassDeletes)) + " feature classes"]
        
    except Exception as err:
        success = False
        messages.append(str(err) + ".")
        messages.append("Failed to delete the majisys feature classes!")
    return success, messages

contentlength = os.environ.get('CONTENT_LENGTH', 0)
postdata = sys.stdin.read(int(contentlength))
postdata = json.loads(postdata)
ticket = postdata['ticket']
curpath = os.path.dirname(os.path.realpath( __file__ ))
cas = SourceFileLoader("cas", curpath + "/../management/cas.py").load_module()
if cas.authorized(ticket,{"basedata" : "rw"}):
    featureclassDeletes = []
    for record in postdata:
        if record == 'ticket':
            continue
        record = postdata[record]
        if 'featureclasskey' in record: # delete
            featureclassDeletes.append(record['featureclasskey'])
    if len(featureclassDeletes) > 0:
        success, messages = deleteFeatureclasses(featureclassDeletes)
    else:
        success = False
        messages = ["Please select at least one feature class to delete."]
else:
    success = False
    messages = ["Not authorized."]

print ("Content-type: application/json")
print ()
if success:
    print("{\"success\": true, \"messages\": " + json.dumps(messages) + "}")
else:
    print("{\"success\": false, \"messages\": " + json.dumps(messages) + "}")

