#!/usr/bin/python3

import os
import cgi
import psycopg2
from datetime import datetime
import sys
import json
from psycopg2.extras import RealDictCursor
from importlib.machinery import SourceFileLoader

def initform():
    params = cgi.FieldStorage()
    ticket = params.getvalue('ticket')
    curpath = os.path.dirname(os.path.realpath( __file__ ))
    cas = SourceFileLoader("cas", curpath + "/../management/cas.py").load_module()
    if not cas.authorized(ticket,{"dataentry" : "r"}):
        print("Content-type: text/plain")
        print()
        print("Not authorized.")
    else:
        username = cas.getusername(ticket)
        print("Content-type: application/json")
        print()

        file = open("../.credentials/.postgres")
        connection_string = file.readline()
        pg = psycopg2.connect(connection_string)
        query = pg.cursor(cursor_factory=RealDictCursor)

        sql = "WITH spatialfilter AS \
               (SELECT ST_Union(geom) AS aoi FROM app.user JOIN app.user_spatialfilter USING(userid) JOIN app.spatialfilter USING (gid) \
                WHERE username='" + username + "') \
                SELECT DISTINCT id FROM fews.locations \
                JOIN fews.stations ON locations.id = stations.station_id \
                JOIN spatialfilter ON ST_Intersects(geom, spatialfilter.aoi) \
                ORDER BY id;"
        query.execute(sql)
        result = json.dumps(query.fetchall())
        print("[{\"locations\":" + result.replace("'",'"') + ",", end='')

        sql = "SELECT featureclasskey, initcap(featureclassname) as featureclassname FROM fews.featureclass;"
        query.execute(sql)
        result = json.dumps(query.fetchall())
        print("\"featureclass\":" + result.replace("'",'"') + ",", end='')

        sql = "SELECT p.id, initcap(p.name) || ' - [' || g.displayunit || ']' AS name, p.featureclasskey \
                FROM fews.parameterstable AS p JOIN fews.parametergroups AS g ON p.groupkey = g.groupkey \
                WHERE p.id NOT LIKE '%calc';"
        query.execute(sql)
        result = json.dumps(query.fetchall())
        print("\"parameters\":" + result.replace("'",'"') + "},{", end='')
        
        sql = "SELECT fullname FROM app.user WHERE username='" + username + "';"
        query.execute(sql)
        result = query.fetchone()['fullname']
        print("\"fullname\":\"" + result + "\"}]")

# main()

initform()


