#!/usr/bin/python3

import json
import os
import psycopg2
import sys
from psycopg2.extras import RealDictCursor

def deleteRole(roleid):
    success = True
    messages = []
    file = open("../.credentials/.postgresadmin")
    connection_string = file.readline()
    pg = psycopg2.connect(connection_string)
    query = pg.cursor(cursor_factory=RealDictCursor)
    try:
        sql = "BEGIN;"
        query.execute(sql)
        sql = "DELETE FROM app.role_navtree WHERE roleid=" + str(roleid)
        query.execute(sql)
        sql = "DELETE from app.role WHERE roleid=" + str(roleid)
        query.execute(sql)
        sql = "COMMIT;"
        query.execute(sql)
        
    except Exception as err:
        success = False
        messages.append(str(err) + ".")
        messages.append("Failed to update the majisys role!")
    return success, messages

contentlength = os.environ.get('CONTENT_LENGTH', 0)
postdata = sys.stdin.read(int(contentlength))
postdata = json.loads(postdata)
querystring = os.environ.get('QUERY_STRING')
querystring = querystring.split('&')
query = {}
for qs in querystring:
    qs = qs.split('=')
    if len(qs) < 2:
        continue
    query[qs[0]] = qs[1]
if 'roleid' in query:
    roleid = query['roleid']
    success, messages = deleteRole(roleid)
else:
    for record in postdata:
        if 'roleid' in record:
            roleid = record['roleid']
            success, messages = deleteRole(roleid)
            if not success:
                break

print ("Content-type: application/json")
print ()
if success:
    print("{\"success\": true, \"messages\": " + json.dumps(messages) + "}")
else:
    print("{\"success\": false, \"messages\": " + json.dumps(messages) + "}")

