#!/usr/bin/python3

import json
import os
import psycopg2
import sys
from psycopg2.extras import RealDictCursor

def updateSpatialFilters(userid, updates):
    success = True
    messages = []
    file = open("../.credentials/.postgresadmin")
    connection_string = file.readline()
    pg = psycopg2.connect(connection_string)
    query = pg.cursor(cursor_factory=RealDictCursor)
    try:
        sql = "BEGIN;"
        query.execute(sql)
        for update in updates:
            gid = update['gid']
            if 'selected' in update:
                selected = update['selected']
                sql = ""
                if selected:
                    sql = "INSERT INTO app.user_spatialfilter(userid,gid) SELECT " + str(userid) + "," + str(gid) + " WHERE NOT EXISTS (SELECT userid,gid FROM app.user_spatialfilter WHERE userid=" + str(userid) + " AND gid=" + str(gid) + ")"
                    query.execute(sql)
                else:
                    sql = "DELETE FROM app.user_spatialfilter WHERE userid=" + str(userid) + " AND gid=" + str(gid)
                    query.execute(sql)
        sql = "COMMIT;"
        query.execute(sql)
        
    except Exception as err:
        success = False
        messages.append(str(err) + ".")
        messages.append("Failed to update the majisys spatialfilters!")
    return success, messages

contentlength = os.environ.get('CONTENT_LENGTH', 0)
postdata = sys.stdin.read(int(contentlength))
postdata = json.loads(postdata)
querystring = os.environ.get('QUERY_STRING')
querystring = querystring.split('&')
query = {}
for qs in querystring:
    qs = qs.split('=')
    if len(qs) < 2:
        continue
    query[qs[0]] = qs[1]
if 'userid' in query:
    userid = query['userid']
    success, messages = updateSpatialFilters(userid, postdata)
else:
    success = False
    messages = ["No userid supplied; nothing to update!"]

print ("Content-type: application/json")
print ()
if success:
    print("{\"success\": true, \"messages\": " + json.dumps(messages) + "}")
else:
    print("{\"success\": false, \"messages\": " + json.dumps(messages) + "}")

