#!/usr/bin/python3

import os
import cgi
import psycopg2
import json
from psycopg2.extras import RealDictCursor

params = cgi.FieldStorage()
roleid = params.getvalue('roleid')

print ("Content-type: application/json")
print ()

file = open("../.credentials/.postgres")
connection_string = file.readline()
pg = psycopg2.connect(connection_string)
query = pg.cursor(cursor_factory=RealDictCursor)
    
if roleid == "0":
    sql_code = """
    SELECT n.text, n.title, n.iconcls AS "iconCls", n.classcolor, n.viewtype AS "viewType",
    n.route, n.position, n.modulename, false AS rendered, true AS leaf, false AS readwrite, null AS children
    FROM app.navtree AS n
    WHERE n.parentid = 0 AND n.modulename IN ('homeguest','about')"""    

elif roleid == "1":
    sql_code = """
    WITH p AS (
      (SELECT n.*, false AS rendered, true AS leaf, false AS readwrite 
      FROM app.navtree AS n JOIN app.role_navtree AS r USING(itemid)
      WHERE n.parentid = 0 AND r.roleid = 1)
      UNION
      (SELECT n.*, false AS rendered, true AS leaf, false AS readwrite 
      FROM app.navtree AS n
      WHERE n.parentid = 0 AND n.modulename = 'help'))
    SELECT p.text, p.title, p.iconcls AS "iconCls", p.classcolor, p.viewtype AS "viewType",
      p.route, p.position, p.modulename, p.rendered, p.leaf, p.readwrite, null AS children 
    FROM p;"""    

else:    
    sql_code = """
    WITH p AS ( 
      (SELECT n.*, 
        false AS rendered, 
        CASE WHEN n.children = false THEN true ELSE false END AS leaf, 
        r.readwrite 
      FROM app.navtree AS n JOIN app.role_navtree as r USING(itemid) 
      WHERE n.parentid = 0 AND r.roleid = %s)
      UNION
      (SELECT n.*, false AS rendered, true AS leaf, false AS readwrite 
      FROM app.navtree AS n
      WHERE n.parentid = 0 AND n.modulename IN ('help','home'))), 
    c AS ( 
      SELECT n.text, n.title, n.iconcls AS "iconCls", n.classcolor, n.viewtype AS "viewType", n.route, 
      false AS rendered, 
        CASE WHEN n.children = false THEN true ELSE false END AS leaf, 
      n.parentid, n.position, n.modulename, r.readwrite 
      FROM app.navtree AS n JOIN app.role_navtree AS r USING(itemid) 
      WHERE n.parentid <> 0 AND r.roleid = %s) 
    SELECT 
      p.text, p.title, p.iconcls AS "iconCls", p.classcolor, p.viewtype AS "viewType", 
      p.route, p.leaf, p.rendered, p.position, p.modulename, p.readwrite, 
      json_agg(c.*) AS children 
    FROM p LEFT JOIN c ON c.parentid = p.itemid 
    GROUP BY 1,2,3,4,5,6,7,8,9,10,11;""" % (roleid, roleid)
    
query.execute(sql_code)
result = json.dumps(query.fetchall())
# unescape json from sql json_agg (not required in newer psycopg2 versions)
result = result.replace('\\n','').replace('\\','').replace('"[','[').replace(']"',']').replace('"{','{').replace('}"','}')
print ('{"children": ' + result.replace('[null]','null') + '}' )
