#!/usr/bin/python3

import os
import cgi
import psycopg2
import json
from psycopg2.extras import RealDictCursor
from management import cas

params = cgi.FieldStorage()
parameterid = params.getvalue('parameterid')
ticket = params.getvalue('ticket')

print ("Content-type: application/json")
print ()

if not cas.authorized(ticket,{"analysis" : "r"}):
    print ('[{"messages": "Not authorized."]')
else:
    username = cas.getusername(ticket)
    file = open(".credentials/.postgres")
    connection_string = file.readline()
    pg = psycopg2.connect(connection_string)
    query = pg.cursor(cursor_factory=RealDictCursor)

    sql_code = "\
        WITH aggregates AS ( \
            SELECT v.serieskey, min(v.datetime) AS startdate, \
                   max(v.datetime) AS enddate \
            FROM fews.timeseriesvaluesandflags as v \
            GROUP BY 1 \
        ), spatialfilter AS \
        (SELECT ST_Union(geom) AS aoi FROM app.user JOIN app.user_spatialfilter USING(userid) JOIN app.spatialfilter USING (gid) \
           WHERE username='" + username + "') \
        SELECT k.serieskey, p.id, l.stationkey, l.station_id AS id, l.station_name AS name, greatest(-180.0, least(180.0, ST_X(l.geom))) AS x, greatest(-85.0, least(85.0, ST_Y(l.geom))) AS y, \
               to_char(a.startdate, 'DD-MM-YYYY') AS startdate, to_char(a.enddate, 'DD-MM-YYYY') as enddate \
        FROM fews.timeserieskeys AS k JOIN fews.parameterstable AS p ON k.parameterkey = p.parameterkey \
             JOIN fews.stations AS l ON l.stationkey = k.locationkey \
             JOIN aggregates AS a ON k.serieskey = a.serieskey \
             JOIN spatialfilter ON ST_Intersects(l.geom, spatialfilter.aoi) \
        WHERE p.id = '%s';" % ( parameterid )
        
    query.execute(sql_code)    
    result = json.dumps(query.fetchall())

    print (result)
