#!/usr/bin/python3

import os
import urllib.request 
from urllib.parse import parse_qsl
import json
import xml.etree.ElementTree as xt

qs = os.getenv('QUERY_STRING')
params = dict(parse_qsl(qs))
url = params['wmsurl'] + '?SERVICE=WMS&REQUEST=GetCapabilities'

success = True
try:
    page = urllib.request.urlopen(url)
except:
    success = False
else:
    response = page.read()
    page.close()

ns = {'wms': 'http://www.opengis.net/wms'}

print ("Content-type: application/json; charset=utf-8")
print ()

list = []
if (success):
    # data = xt.fromstring(response.decode('utf-8'))
    data = xt.fromstring(response.decode('unicode_escape').encode('ascii','ignore'))
    layers = data.find('wms:Capability', ns).find('wms:Layer', ns)
    for child in layers.findall('wms:Layer', ns):
        list.append({'name': child.find('wms:Name', ns).text, 
                     'title': child.find('wms:Title', ns).text,
                     'abstract': str(child.find('wms:Abstract', ns).text).replace('\n',' ')})

print('{"records" : ' + json.dumps(list) + '}')
